include doszip.inc
include io.inc
include iost.inc
include string.inc
include stdlib.inc
include errno.inc
ifdef __TE__
include stdio.inc
include keyb.inc
include alloc.inc
endif
ifdef __TE__
externdef	IDD_TEOptions:dword
endif

command		proto :dword
__AT__		equ 1
public		format_u

.data

format_u	db	"%u",0
cf_panel	db	0
cf_panel_upd	db	0
cf_screen_upd	db	0
cp_cmdreload	db	'ECHO.',0
cp_pal		db	'*.pal',0

color_Mono	db	00h,00h,00h,00h,00h,70h,70h,00h
		db	0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,70h,0Fh
		db	0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh,0Fh
color_Black	db	00h,00h,00h,00h,00h,10h,10h,00h
		db	07h,07h,0Fh,07h,08h,08h,10h,07h
		db	08h,07h,0Ah,0Bh,0Fh,0Bh,0Bh,0Bh
color_Blue	db	00h,10h,70h,70h,40h,30h,30h,70h
		db	00h,0Fh,0Fh,07h,08h,00h,30h,07h
		db	08h,00h,0Ah,0Bh,00h,0Fh,0Fh,0Fh
color_Norton	db	00h,10h,70h,30h,40h,0F0h,30h,70h
		db	07h,0Bh,0Fh,07h,08h,00h,30h,07h
		db	08h,0Fh,0Eh,0Bh,00h,00h,0Eh,0Eh
color_White	db	00h,00h,0F0h,0F0h,40h,70h,30h,70h
		db	00h,07h,0Fh,07h,08h,08h,70h,07h
		db	08h,00h,0Ah,0Bh,00h,0Fh,06h,04h
color_Table	label dword
		dd offset color_Blue
		dd offset color_Black
		dd offset color_Mono
		dd offset color_White
		dd offset color_Norton

.code

cmsystem proc uses esi edi ebx
local	DLG_DZSystemOptions:dword
	.if rsopen(IDD_DZSystemOptions)
	    mov DLG_DZSystemOptions,eax
	    mov ebx,eax
	    mov eax,cflag
	    .if eax & _C_DELHISTORY
		or [ebx+7*16].S_TOBJ.to_flag,_O_FLAGB
	    .endif
	    .if eax & _C_ESCUSERSCR
		or [ebx+8*16].S_TOBJ.to_flag,_O_FLAGB
	    .endif
	    invoke tosetbitflag,[ebx].S_DOBJ.dl_object,6,_O_FLAGB,console
	    invoke dlinit,ebx
	    invoke rsevent,IDD_DZSystemOptions,ebx
	    mov esi,eax
	    invoke togetbitflag,[ebx].S_DOBJ.dl_object,8,_O_FLAGB
	    invoke dlclose,ebx
	    mov eax,esi
	    .if eax
		mov eax,edx
		mov edx,cflag
		and edx,not (_C_DELHISTORY or _C_ESCUSERSCR)
		.if al & 40h	; Auto Delete History
		    or edx,_C_DELHISTORY
		.endif
		.if al & 80h	; Use Esc for user screen
		    or edx,_C_ESCUSERSCR
		.endif
		mov cflag,edx
		and eax,3Fh
		mov edx,console
		mov ecx,edx
		and edx,not 3Fh
		or  eax,edx
		mov console,eax
		and eax,CON_MOUSE or CON_IOLFN
		and ecx,CON_MOUSE or CON_IOLFN
		.if ecx != eax
		    mov ecx,ENABLE_WINDOW_INPUT
		    .if eax & CON_MOUSE
			or ecx,ENABLE_MOUSE_INPUT
		    .endif
		    invoke SetConsoleMode,hStdInput,ecx
		    .if cf_panel == 1
			mov cf_panel_upd,1
		    .else
			invoke redraw_panels
		    .endif
		.endif
		mov eax,1
	    .endif
	.endif
	ret
cmsystem endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ID_MEUSLINE	equ 1*16
ID_USEDATE	equ 2*16
ID_USETIME	equ 3*16
ID_USELDATE	equ 4*16
ID_USELTIME	equ 5*16
ID_COMMANDLINE  equ 6*16
ID_STAUSLINE	equ 7*16
ID_ATTRIB	equ 8*16
ID_STANDARD	equ 9*16
ID_LOAD		equ 10*16
ID_SAVE		equ 11*16

event_reload proc private
	.if cf_panel == 0
	    invoke dlhide,tdialog
	    invoke apiupdate
	    invoke dlshow,tdialog
	    mov eax,_C_NORMAL
	.else
	    mov cf_screen_upd,1
	    mov eax,_C_ESCAPE
	.endif
	ret
event_reload endp

event_loadcolor proc private uses esi
	.if wgetfile(addr cp_pal,3)
	    push eax
	    invoke osread,eax,addr at_background,SIZE S_COLOR
	    mov esi,eax
	    call close
	    mov eax,_C_NORMAL
	    .if esi == SIZE S_COLOR
		invoke event_reload
	    .endif
	.endif
	ret
event_loadcolor endp

event_savecolor proc private
	.if wgetfile(addr cp_pal,2)
	    push eax
	    invoke oswrite,eax,addr at_background,SIZE S_COLOR
	    call close
	.endif
	mov eax,_C_NORMAL
	ret
event_savecolor endp

ifdef __AT__

event_editat proc private
	invoke  editattrib
	test	eax,eax
	jnz	event_reload
	mov	eax,_C_NORMAL
	ret
event_editat endp

endif

event_standard proc private
	mov eax,tdialog
	mov ax,[eax+4]
	add ax,0B0Ch
	mov ecx,IDD_DZDefaultColor
	mov [ecx+6],ax
	.if rsmodal(ecx)
	    .if eax < 6
		dec eax
		mov eax,color_Table[eax*4]
		invoke memcpy,addr at_background,eax,sizeof(S_COLOR)
		invoke event_reload
	    .else
		sub eax,eax
	    .endif
	.else
	    inc eax
	.endif
	ret
event_standard endp

cmscreen proc uses esi edi
	mov cf_screen_upd,0
	.if rsopen(IDD_DZScreenOptions)
	    mov edi,eax
	    mov dl,_O_FLAGB
	    mov eax,cflag
	    .if eax & _C_MENUSLINE
		or [edi][ID_MEUSLINE],dl
	    .endif
	    .if eax & _C_COMMANDLINE
		or [edi][ID_COMMANDLINE],dl
	    .endif
	    .if eax & _C_STATUSLINE
		or [edi][ID_STAUSLINE],dl
	    .endif
	    mov eax,console
	    .if eax & CON_UDATE
		or [edi][ID_USEDATE],dl
	    .endif
	    .if eax & CON_LDATE
		or [edi][ID_USELDATE],dl
	    .endif
	    .if eax & CON_UTIME
		or [edi][ID_USETIME],dl
	    .endif
	    .if eax & CON_LTIME
		or [edi][ID_USELTIME],dl
	    .endif
ifdef __AT__
	    mov [edi].S_TOBJ.to_proc[ID_ATTRIB],event_editat
else
	    or [edi].S_TOBJ.to_flag[ID_ATTRIB],_O_STATE
endif
	    mov [edi].S_TOBJ.to_proc[ID_STANDARD],event_standard
	    mov [edi].S_TOBJ.to_proc[ID_LOAD],event_loadcolor
	    mov [edi].S_TOBJ.to_proc[ID_SAVE],event_savecolor
	    invoke dlinit,edi
	    invoke rsevent,IDD_DZScreenOptions,edi
	    mov esi,eax
	    lea eax,[edi+16]
	    invoke togetbitflag,eax,7,_O_FLAGB
	    invoke dlclose,edi  ; return bit-flag in DX
	    mov eax,esi
	    mov esi,cflag
	    .if eax
		mov eax,edx
		mov edx,console
		and edx,not (CON_UTIME or CON_UDATE or CON_LTIME or CON_LDATE)
		.if al & 02h
		    or edx,CON_UDATE
		.endif
		.if al & 08h
		    or edx,CON_LDATE
		.endif
		.if al & 04h
		    or edx,CON_UTIME
		.endif
		.if al & 10h
		    or edx,CON_LTIME
		.endif
		and esi,not (_C_MENUSLINE or _C_STATUSLINE or _C_COMMANDLINE)
		.if al & 01h
		    or esi,_C_MENUSLINE
		.endif
		.if al & 20h
		    or esi,_C_COMMANDLINE
		.endif
		.if al & 40h
		    or esi,_C_STATUSLINE
		.endif
		.if console != edx
		    mov console,edx
		    .if cflag & _C_MENUSLINE
			invoke scputw,60,0,20,' '
		    .endif
		.endif
		.if cflag != esi || cf_screen_upd
		    mov cf_screen_upd,0
		    mov cflag,esi
		    .if cf_panel == 1
			invoke dlhide,tdialog
		    .endif
		    invoke apiupdate
		    .if cf_panel == 1
			invoke dlshow,tdialog
		    .endif
		.endif
	    .endif
	    mov eax,_C_NORMAL
	.endif
	ret
cmscreen endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cmpanel proc uses ebx
	.if rsopen(IDD_DZPanelOptions)
	    mov ebx,eax
	    mov edx,_O_FLAGB
	    mov eax,cflag
	    .if eax & _C_INSMOVDN
		or [ebx+1*16],dl
	    .endif
	    .if eax & _C_SELECTDIR
		or [ebx+2*16],dl
	    .endif
	    .if eax & _C_SORTDIR
		or [ebx+3*16],dl
	    .endif
	    .if eax & _C_CDCLRDONLY
		or [ebx+4*16],dl
	    .endif
	    invoke dlinit,ebx
	    invoke rsevent,IDD_DZPanelOptions,ebx
	    push   eax
	    mov	   eax,ebx
	    add	   eax,SIZE S_DOBJ
	    invoke togetbitflag,eax,4,_O_FLAGB
	    invoke dlclose,ebx
	    pop eax
	    .if eax
		mov eax,edx
		and path_a.wp_flag,not _W_SORTSUB
		and path_b.wp_flag,not _W_SORTSUB
		mov edx,cflag
		and edx,not (_C_INSMOVDN or _C_SELECTDIR or _C_SORTDIR or _C_CDCLRDONLY)
		.if al & 1
		    or edx,_C_INSMOVDN
		.endif
		.if al & 2
		    or edx,_C_SELECTDIR
		.endif
		.if al & 4
		    or edx,_C_SORTDIR
		    or path_a.wp_flag,_W_SORTSUB
		    or path_b.wp_flag,_W_SORTSUB
		.endif
		.if al & 8
		    or edx,_C_CDCLRDONLY
		.endif
		.if cflag != edx
		    mov cflag,edx
		    mov ecx,_diskflag
		    mov byte ptr [ecx],1
		.endif
		mov eax,1
	    .endif
	.endif
	ret
cmpanel endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cmconfirm proc uses ebx
	.if rsopen(IDD_DZConfirmations)
	    mov ebx,eax
	    mov eax,config.c_cflag
	    shr eax,16
	    invoke tosetbitflag,[ebx].S_DOBJ.dl_object,7,_O_FLAGB,eax
	    invoke dlinit,ebx
	    invoke rsevent,IDD_DZConfirmations,ebx
	    push eax
	    invoke togetbitflag,[ebx].S_DOBJ.dl_object,7,_O_FLAGB
	    invoke dlclose,ebx
	    pop eax
	    .if eax
		mov eax,config.c_cflag
		and eax,not 007F0000h
		shl edx,16
		or  eax,edx
		mov config.c_cflag,eax
	    .endif
	.endif
	ret
cmconfirm endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cmcompression proc uses ebx
	.if rsopen(IDD_DZCompression)
	    mov ebx,eax
	    mov eax,compresslevel
	    .if al > 9
		mov al,6
		mov compresslevel,eax
	    .endif
	    inc eax
	    shl eax,4
	    add eax,ebx
	    or  [eax].S_DOBJ.dl_flag,_O_RADIO
	    .if cflag & _C_ZINCSUBDIR
		or [ebx].S_DOBJ.dl_flag[11*16],_O_FLAGB
	    .endif
	    invoke dlinit,ebx
	    .if rsevent(IDD_DZCompression,ebx)
		mov eax,cflag
		and eax,not _C_ZINCSUBDIR
		.if [ebx].S_DOBJ.dl_flag[11*16] & _O_FLAGB
		    or eax,_C_ZINCSUBDIR
		.endif
		mov cflag,eax
		xor eax,eax
		mov edx,ebx
		.repeat
		    add edx,SIZE S_TOBJ
		    .break .if [edx].S_DOBJ.dl_flag & _O_RADIO
		    inc eax
		.until eax == 10
		.if eax == 10
		    mov eax,6
		.endif
		mov compresslevel,eax
	    .endif
	    invoke dlclose,ebx
	.endif
	ret
cmcompression endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ifdef __TE__

ID_USEMENUS	equ 1*16
ID_OPTIMALFILL  equ 2*16
ID_OVERWRITE	equ 3*16
ID_USEINDENT	equ 4*16
ID_USESTYLE	equ 5*16
ID_USETABS	equ 6*16
ID_USEBAKFILE	equ 7*16
ID_USECRLF	equ 8*16
ID_TABSIZE	equ 9*16
ID_LINESIZE	equ 10*16

teoption proc uses ebx
	.if rsopen(IDD_TEOptions)
	    mov ebx,eax
	    mov eax,titabsize
	    invoke sprintf,[ebx].S_TOBJ.to_data[ID_TABSIZE],addr format_u,eax
	    mov eax,128
	    mov ecx,telsize
	    shl eax,cl
	    invoke sprintf,[ebx].S_TOBJ.to_data[ID_LINESIZE],addr format_u,eax
	    mov eax,teflag
	    shr eax,5
	    invoke tosetbitflag,[ebx].S_DOBJ.dl_object,8,_O_FLAGB,eax
	    invoke dlinit,ebx
	    .if rsevent(IDD_TEOptions,ebx)
		invoke togetbitflag,[ebx].S_DOBJ.dl_object,8,_O_FLAGB
		shl eax,5
		mov teflag,eax
		invoke strtol,[ebx].S_TOBJ.to_data[ID_TABSIZE]
		mov ah,al
		mov al,128
		.repeat
		    shl ah,1
		    .break .if CARRY?
		    shr al,1
		.until ZERO?
		.if al > TIMAXTABSIZE
		    mov al,TIMAXTABSIZE
		.elseif al < 2
		    mov al,2
		.endif
		movzx eax,al
		mov titabsize,eax
		invoke strtol,[ebx].S_TOBJ.to_data[ID_LINESIZE]
		bsr eax,eax
		.if eax > 10
		    mov eax,10
		.elseif eax < 7
		    mov eax,7
		.endif
		sub eax,7
		mov telsize,eax
	    .endif
	    invoke dlclose,ebx
	    mov eax,edx
	.endif
	ret
teoption endp

endif

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cmoptions proc uses esi ebx
	mov cf_panel,1
	mov cf_panel_upd,0
	.if rsopen(IDD_DZConfiguration)
	    mov ebx,eax
	  ifdef __TE__
	    mov [ebx].S_TOBJ.to_proc[4*16],teoption
	  else
	    mov [ebx].S_TOBJ.to_proc[4*16],notsup
	  endif
	    mov [ebx].S_TOBJ.to_proc[5*16],cmconfirm
	    mov [ebx].S_TOBJ.to_proc[6*16],cmcompression
	    mov [ebx].S_TOBJ.to_proc[1*16],cmsystem
	    mov [ebx].S_TOBJ.to_proc[2*16],cmscreen
	    mov [ebx].S_TOBJ.to_proc[3*16],cmpanel
	    .if cflag & _C_AUTOSAVE
		or byte ptr [ebx+7*16],_O_FLAGB
	    .endif
	    invoke dlinit,ebx
	    invoke rsevent,IDD_DZConfiguration,ebx
	    push [ebx+7*16]
	    invoke dlclose,ebx
	    mov cf_panel_upd,0
	    pop eax
	    .if edx
		and cflag,not _C_AUTOSAVE
		.if al & _O_FLAGB
		    or cflag,_C_AUTOSAVE
		.endif
	    .endif
	    call redraw_panels
	.endif
	mov cf_panel,0
	ret
cmoptions endp

	END
