include doszip.inc
include string.inc
include io.inc

.code
;
; buf (DZ.INI): <command> [options+macros]
; fbname: file name or full path
;
cmdlparse proc uses esi edi ebx buf:dword, fbname:dword
local longp[WMAXPATH]:byte
local cpath[MAXPATH]:byte
local fname[MAXFILE+MAXEXT]:byte
local longf:dword
local S2[4]:byte
local S1[4]:byte
	invoke  strchr,buf,'!'  ; file macro used ?
	jnz	parse_type_do
	lea	ebx,S1
	mov	al,' '
	mov	[ebx],al
	mov	byte ptr [ebx+1],'"'
	mov	[ebx+2],ah
	invoke  strchr,fbname,eax
	mov	esi,eax
	jnz	parse_type_00
	mov	[ebx+1],al
    parse_type_00:
	invoke  strcat,buf,ebx
	invoke  strcat,eax,fbname
	or	esi,esi
	jz	parse_type_01
	inc	ebx
	invoke  strcat,eax,ebx
    parse_type_01:
	xor	ebx,ebx
	jmp	parse_type_end
    parse_type_do:
	lea	esi,S1
	lea	edi,S2
	xor	eax,eax
	mov	[esi+2],ax
	mov	[edi+2],ax
	invoke  wlongpath,0,fbname
	lea	edx,longp
	invoke  strcpy,edx,eax
	mov eax,fbname
	mov eax,[eax]
	.if al == '\' || ah == ':'
	    invoke strcpy,addr cpath,addr longp
	    push eax
	    invoke strfn,addr cpath
	    pop edx
	    .if eax != edx
		mov byte ptr [eax-1],0
	    .endif
	    lea edx,fname
	    invoke strncpy,edx,eax,14
	.else
	    invoke getcwd,addr cpath,WMAXPATH
	    or eax,eax
	    jz parse_type_end
	    invoke wshortname,fbname
	    lea edx,fname
	    invoke strncpy,edx,eax,14
	.endif
	mov	eax,''
	mov	[edi],ax
	mov	eax,'!!'
	mov	edx,edi
	mov	ecx,2
	call	parse_xchg
	invoke  strrchr,addr fname,'.'
	mov	edx,eax
	jnz	parse_type_ext
	mov	edx,edi			; remove extension code from line
	mov	[edi],al
    parse_type_ext:
	mov	ebx,edx
	mov	eax,'!.'		; '.!~' - short extension
	mov	ch,'~'
	mov	cl,3
	call	parse_xchg
	mov	byte ptr [ebx],0	; remove extension
	invoke  strfn,addr longp	; '.!' - long extension
	mov	longf,eax		; file offset
	invoke  strrchr,eax,'.'
	mov	edx,eax
	jnz	parse_type_lext
	mov	edx,edi
	mov	[edi],al
    parse_type_lext:
	mov	ebx,edx
	mov	eax,'!.'
	mov	ecx,2
	call	parse_xchg
	mov	ecx,2
	mov	[ebx],ch		; remove extension
	lea	ebx,cpath	; '!:' - Drive + ':'
	mov	edx,ebx
	mov	[ebx+2],ch
	mov	eax,':!'
	call	parse_xchg
	lea	ebx,cpath	; '!~\' - Short path
	add	ebx,2
	mov	edx,ebx
	mov	ch,'\'
	mov	cl,3
	mov	eax,'~!'
	mov	[ebx],ch
	call	parse_xchg
	lea	eax,longp	; '!\' - Long path
	mov	ebx,longf
	mov	edx,eax
	mov	ecx,2
	cmp	eax,ebx
	je	parse_type_longp
	add	edx,ecx
	dec	ebx
	mov	[ebx],ch		; remove \file name
    parse_type_longp:
	mov	eax,'\!'
	call	parse_xchg
	lea	edx,fname	; '~!' - Short file
	mov	ecx,2
	mov	eax,'!~'
	call	parse_xchg
	mov	edx,longf	; '!' - Long file
	mov	ecx,1
	mov	eax,'!'
	call	parse_xchg
	mov	eax,'!'
	mov	[edi],eax
	mov	eax,''
	mov	edx,edi
	mov	ecx,2
	call	parse_xchg
	inc	edi
    parse_type_end:
	ret
parse_xchg:
	mov	[esi],ax
	mov	[esi+2],ch
	movzx	ecx,cl
	invoke  strxchg,buf,esi,edx,ecx
	retn
cmdlparse endp

	END
